<template>
    <div id="inspire">
        <v-app-bar app color="black" dark class="appbar1">
            <v-app-bar-nav-icon @click.stop="showDrawer = !showDrawer"></v-app-bar-nav-icon>
            <v-toolbar-title>
                <a href="/">
                    <img style="width: 150px;" src="~@/assets/icons/bee-blanco.svg" class="logoicon" />
                </a>
            </v-toolbar-title>
            <v-spacer></v-spacer>
            <!-- <v-btn icon class="hidden-xs-only" @click="back">
                <v-icon>mdi-arrow-left</v-icon>
            </v-btn>-->
            <div class="menu-actions">
                <Notification style="margin-right: 25px; margin-top: 5px;"></Notification>
                <UserIcon style="margin-right:10px;" :name="user.name" class="usericons"></UserIcon>
                <div class="user-info">
                    <span>{{ user.name }}</span>
                    <span class="logout" @click="logout">Cerrar sesión</span>
                </div>
            </div>
        </v-app-bar>
        <v-navigation-drawer v-model="showDrawer" dark color="black" temporary app>
            <v-list>
                <v-list-item>
                    <img style="width: 150px;margin-bottom:17px;" src="~@/assets/icons/bee-blanco.svg" />
                </v-list-item>
                <v-list-item link v-for="item of menuItems" :key="item.name" :to="{ name: item.route }" dense>
                    <v-list-item-action>
                        <img v-if="item.icon == 'home'" style="width: 30px;" src="~@/assets/icons/inicio.svg" />
                        <img v-else-if="item.icon == 'menus'" style="width: 30px;" src="~@/assets/icons/menu.svg" />
                        <img v-else-if="item.icon == 'dishes'" style="width: 30px;" src="~@/assets/icons/dishes.svg" />
                        <img v-else-if="item.icon == 'orders'" style="width: 30px;" src="~@/assets/icons/ordenes.svg" />
                        <img
                            v-else-if="item.icon == 'kpi'"
                            style="width: 30px;"
                            src="~@/assets/icons/indicadores.svg"
                        />
                        <img v-else-if="item.icon == 'help'" style="width: 30px;" src="~@/assets/icons/atencion.svg" />
                        <img
                            v-else-if="item.icon == 'delivery'"
                            style="width: 30px; "
                            src="~@/assets/icons/truck-fast-outline.svg"
                        />
                    </v-list-item-action>
                    <v-list-item-content>
                        <v-list-item-title>{{ item.name | capitalize }}</v-list-item-title>
                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </v-navigation-drawer>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { RouteConfig } from 'vue-router';
import { namespace, State } from 'vuex-class';
import { User } from '@/model/User';
import UserIcon from '@/components/commons/UserIcon.vue';
import Notification from '@/components/notification/Notification.vue';

const loginStore = namespace('LoginModule');

@Component({
    components: {
        UserIcon,
        Notification
    },
    filters: {
        capitalize: function(text: string) {
            if (!text) return '';
            text = text.toString();

            return text.replace(/([A-Z])/g, ' $1').replace(/^./, function(str) {
                return str.toUpperCase();
            });
        }
    }
})
export default class Menu extends Vue {
    @Prop({
        default: []
    })
    routes!: RouteConfig[];

    showDrawer = false;

    @State('showHomeIcon')
    showHomeIcon!: boolean;

    @loginStore.Action
    logout!: () => Promise<void>;

    @loginStore.State
    user!: User;

    get menuItems(): { name?: string; icon?: string; route?: string }[] {
        return this.routes
            .filter(r => r.meta?.menu)
            .map(r => {
                return {
                    name: r.name,
                    icon: r.meta.icon,
                    route: r.name
                };
            });
    }

    back() {
        this.$router.back();
    }
}
</script>

<style lang="scss" scoped>
.menu-actions {
    display: flex;
    .user-info {
        display: flex;
        flex-direction: column;
        align-items: flex-end;
        .logout {
            font-size: 10px;
            cursor: pointer;
        }
    }
}
@media (max-width: 700px) {
    .logoicon {
        height: 30px;
        margin-left: -40px;
    }
    .menu-actions {
        margin-top: 15px;
        font-size: 10px;
    }
    .appbar1 {
        position: relative;
        height: 200px;
    }
    .logout {
        color: #fbc02d;
    }
    .usericons {
        width: 20px;
        height: 10px;
        margin-top: -10px;
    }
}
</style>
